# coding: utf-8

"""
    aind-slims-service

     ## aind-slims-service  Service to pull data from SLIMS.  

    The version of the OpenAPI document: 0.2.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class EcephysRewardSpouts(BaseModel):
    """
    Expected Reward Spouts information from SLIMS
    """ # noqa: E501
    spout_side: Optional[StrictStr] = None
    starting_position: Optional[StrictStr] = None
    variable_position: Optional[StrictBool] = None
    __properties: ClassVar[List[str]] = ["spout_side", "starting_position", "variable_position"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EcephysRewardSpouts from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if spout_side (nullable) is None
        # and model_fields_set contains the field
        if self.spout_side is None and "spout_side" in self.model_fields_set:
            _dict['spout_side'] = None

        # set to None if starting_position (nullable) is None
        # and model_fields_set contains the field
        if self.starting_position is None and "starting_position" in self.model_fields_set:
            _dict['starting_position'] = None

        # set to None if variable_position (nullable) is None
        # and model_fields_set contains the field
        if self.variable_position is None and "variable_position" in self.model_fields_set:
            _dict['variable_position'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EcephysRewardSpouts from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "spout_side": obj.get("spout_side"),
            "starting_position": obj.get("starting_position"),
            "variable_position": obj.get("variable_position")
        })
        return _obj


